ALTER PROCEDURE [dbo].[P_DriverTaksaIndividualWeekCalcDriver](@Driver int,@ReCalcWeek int=-1, --    -1 -   (     "")
@CalcNow bit=1 --1 -   "", 0-   
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <18.12.2013>
-- Update date: <05.09.2016>
-- Description:	<     1 >
-- =============================================
SET NOCOUNT ON;
DECLARE @TaksaDateBeginType	int,	--  , : 0- , 1- 
@TaksaPeriodType	int;	--    // : 0- , 1- 

DECLARE @taxi_taksa money, @UniKey int,@Count int=0,
@PrevDayA datetime, @PrevDayB datetime, @Comment varchar(128),
@PrevWeekFirstDay datetime, @isOrderExists bit,@PrevDayIndivid datetime,
 @isOrdersExists bit=0, @TmpKey int,@Amount money,@DriverTaksaCashIn int, @DriverTaksaCash int,
 @DatePeriodBegin datetime,@DatePeriodEnd datetime, @DriverTaksaItemKey int, @DriverTaksakey int;
 
SET @PrevWeekFirstDay=DATEADD(WW,@ReCalcWeek,GETDATE()); -- -1-   
-- ,  
SET @PrevDayA=CAST(@PrevWeekFirstDay as DATE);
SET @PrevDayA=DATEADD(dd,1-datepart(dw,@PrevDayA),@PrevDayA);
print @PrevDayA;
-- 
SET @PrevDayB=DATEADD(dd,7,@PrevDayA);
SET @PrevDayB=DATEADD(ss,-1,@PrevDayB);
--print @PrevDayB;

--     
if @CalcNow=0 SET @PrevDayIndivid=@PrevDayA;	--. 
if @CalcNow=1 SET @PrevDayIndivid=GETDATE();	-- 			
SET @taxi_taksa=NULL;
SELECT TOP 1 @DriverTaksakey=UniKey, @taxi_taksa=taxi_taksa,@TaksaDateBeginType=TaksaDateBeginType,
	@TaksaPeriodType=TaksaPeriodType,@isOrderExists=isOrderExists
	FROM Taksa TTT WITH(nolock) WHERE Driver=@Driver AND TaksaType=3 AND
	DATEIN<=@PrevDayIndivid AND (DATEOUT>=@PrevDayIndivid OR DATEOUT IS NULL)
		ORDER BY TTT.DATEIN DESC;
	
--print @DriverTaksakey;
if @DriverTaksakey IS NULL return;
--print @taxi_taksa;
if @taxi_taksa=0 return;

if @isOrderExists=1
	begin
	--    
	SELECT @Count=COUNT(bbb.UniKey) FROM BASE bbb WITH (nolock) LEFT JOIN ZakazExitType ZET ON ZET.UniKey=bbb.OtkazClienta 
		WHERE ZET.IsError=0 AND bbb.Driver=@Driver AND 
		(CASE WHEN bbb.DateBegin IS NOT NULL THEN DateBegin ELSE bbb.DATEIN END)>=@PrevDayA AND
		(CASE WHEN bbb.DateBegin IS NOT NULL THEN DateBegin ELSE bbb.DATEIN END)<=@PrevDayB;
	SET @Count=ISNULL(@Count,0);
--	print @Count;
	if @Count=0 return;
	end;

	-- ,   -      
	if @TaksaDateBeginType=0
		begin
				--   
				if @TaksaPeriodType=0 -- 
					begin
					SET @DatePeriodBegin=@PrevDayA;
					SET @DatePeriodEnd=@PrevDayB;
					end
					else
					begin
					SET @DatePeriodBegin=DATEADD(WW,1,@PrevDayA);
					SET @DatePeriodEnd=DATEADD(WW,1,@PrevDayB);
					end;
		end;			
	--   -  ,    
	if @TaksaDateBeginType=1
		begin
				if @TaksaPeriodType=0
					SET @PrevWeekFirstDay=DATEADD(WW,-1,GETDATE()); -- -1- 
					else
					SET @PrevWeekFirstDay=GETDATE(); -- 
				SET @PrevDayA=DATEADD(WW,-1,GETDATE());	--   
				SET @PrevDayB=GETDATE();				--   
				SET @DatePeriodBegin=@PrevWeekFirstDay;
				SET @DatePeriodEnd=DATEADD(WW,1,@PrevWeekFirstDay);
		end;
--print @DatePeriodBegin;
--print @DatePeriodEnd;
		
	SET @UniKey=NULL;
	SELECT TOP 1 @TmpKey=CashInKey,@UniKey=UniKey,@PrevDayA=DateBegin,@PrevDayB=DateEnd,@Amount=Amount
				FROM DriverTaksaCash DTC with(nolock) WHERE Driver=@Driver AND DriverTaksaItemKey IS NULL
				AND DTC.TaksaKey=@DriverTaksakey
				AND ((DTC.DateBegin<=@DatePeriodBegin AND DTC.DateEnd>=@DatePeriodBegin) OR
					(DTC.DateBegin<=@DatePeriodEnd AND DTC.DateEnd>=@DatePeriodEnd) 
				);
				
	if @UniKey IS NULL
		begin
		SELECT TOP 1 @DriverTaksaCashIn=DriverTaksaCashIn, @DriverTaksaCash=DriverTaksaCash FROM PROPERTIES;
		
				--    
				SET @Comment='week tariff '+CAST(@DatePeriodBegin as varchar(22))+'==>'+CAST(@DatePeriodEnd as varchar(22));
				INSERT INTO CashIn (COMMENT,DRIVER,CreateDate,CashType,TYPEOF,SUMMA,DATEOF) VALUES
					(@Comment,@Driver,GETDATE(),@DriverTaksaCash,@DriverTaksaCashIn,@taxi_taksa,GETDATE());
				SET @TmpKey=SCOPE_IDENTITY();
				INSERT INTO DriverTaksaCash(Driver,Amount,TaksaKey,CashInKey,DateBegin,DateEnd,DriverTaksaItemKey)
					VALUES(@Driver,@taxi_taksa,@DriverTaksakey,@TmpKey,@DatePeriodBegin,@DatePeriodEnd, NULL);
				UPDATE DriversPlace SET ActiveBalance=ActiveBalance-@taxi_taksa WHERE Driver=@Driver;
				--SET @Count=@Count+1;
--				print 'INSERT DriverTaksaCash '+CAST(@DatePeriodBegin as varchar(22))+'==>'+CAST(@DatePeriodEnd as varchar(22));
		end
		else 
		begin
			if @PrevDayA=@DatePeriodBegin AND @PrevDayB=@DatePeriodEnd AND @Amount!=@taxi_taksa
				begin
					--     
--					print 'UPDATE CashIn '+CAST(@DatePeriodBegin as varchar(22))+'==>'+CAST(@DatePeriodEnd as varchar(22));
					UPDATE CashIn SET SUMMA=@taxi_taksa,Comment=@Comment WHERE UNIKEY=@TmpKey;
					UPDATE DriverTaksaCash SET Amount=@taxi_taksa WHERE UniKey=@UniKey;
					UPDATE DriversPlace SET ActiveBalance=ActiveBalance-@taxi_taksa+@Amount WHERE Driver=@Driver;
				end;
		end;		
END